"""IBM WebSphere Application Server Patterns

  Copyright IBM Corp. 2014
  All rights reserved.
  US Government Users Restricted Rights -
  Use, duplication or disclosure restricted
  by GSA ADP Schedule Contract with IBM Corp.

  Licensed Materials-Property of IBM
"""
def convertToList(inlist):
     outlist=[]
     if (len(inlist)>0 and inlist[0]=='[' and inlist[len(inlist)-1]==']'):
        inlist = inlist[1:len(inlist)-1]
        clist = inlist.split("\"")
     else:
        clist = inlist.split("\n")
     for elem in clist:
        elem=elem.rstrip();
        if (len(elem)>0):
           outlist.append(elem)
     return outlist

def getCellName():
  cell = AdminConfig.getid('/Cell:/')
  name = AdminConfig.showAttribute(cell,"name")
  return name

def getNodeName():
  servers = convertToList(AdminTask.listServers('[-serverType DEPLOYMENT_MANAGER]'))
  for server in servers:
    serverName = AdminConfig.showAttribute(server,"name")
    if (serverName=="dmgr"):
      tokens = server.split('/')
      return tokens[3]
  return None

def getXdStorageMBean():
  cellName = getCellName()
  nodeName = getNodeName()
  xdStorageMBean = AdminControl.queryNames("WebSphere:name=XdStorage,type=XdStorage,mbeanIdentifier=XdStorage,process=dmgr,cell="+cellName+",node="+nodeName+",*")
  return xdStorageMBean

def getValue(xdStorageMBean, key):
  rc = 0
  val = AdminControl.invoke(xdStorageMBean, "getValue", key)
  if (val == None or val == ""):
     rc = 0
  else:
     rc = val
  return rc

def setValue(xdStorageMBean, key, value):
  AdminControl.invoke(xdStorageMBean, "setValue", [key, value])
  AdminConfig.save()

key = ""
value = ""
command = ""
keySpecified=0
valSpecified=0
idx = 0
if (len(sys.argv)>0):
   for arg in sys.argv:
     if (idx == 0):
        command = sys.argv[0]
        idx = idx + 1
     if (arg.startswith("-key:")):
        parts = arg.split(":")
        key=parts[1]
        keySpecified=1
     elif (arg.startswith("-value:")):
        parts = arg.split(":")
        value=parts[1]
        valSpecified=1

if (command == "setValue" and (keySpecified == 0 or valSpecified == 0)):
  print "Please specify -key:<key name> -value:<value> parameters"
  sys.exit(1)

if (command == "getValue" and keySpecified == 0):
  print "Please specify -key:<key name> parameter"
  sys.exit(1)

try:
  xdStorageMBean = getXdStorageMBean()
  if (command == "setValue"):
    setValue(xdStorageMBean, key, value)
  elif (command == "getValue"):
    val = getValue(xdStorageMBean, key)
    if (val > 0):
      java.lang.System.exit(101)
    else:
      java.lang.System.exit(100)
except:
  java.lang.System.exit(1)

